image: maven:3.8-openjdk-11-slim

variables:
  MAVEN_CLI_OPTS: "--batch-mode -s .m2/ci_settings.xml"
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"

cache:
  paths:
    - .m2/repository/

build:
  stage: build
  script:
    - mvn $MAVEN_CLI_OPTS compile
  artifacts:
    expire_in: 10 min
    paths:
      - target/
      - "*/target"

# Regex to use for coverage display in gitlab: Total.*(\d+.?\d+).*%
# Use `find . -name "*.class" -exec touch {} \+` so maven will not rebuild classes.
# See https://blog.deniger.net/post/gitlab-maven-optimize-build/
test:
  stage: test
  script:
    - find . -name "*.class" -exec touch {} \+
    - mvn $MAVEN_CLI_OPTS verify
    - cat target/site/jacoco/index.html | grep -o 'Total[^%]*%'
  artifacts:
    reports:
      junit: [ target/failsafe-reports/*.xml, target/surefire-reports/*.xml ]

deploy:
  stage: deploy
  script:
    - find . -name "*.class" -exec touch {} \+
    - mvn $MAVEN_CLI_OPTS -Dmaven.test.skip=true deploy
  only:
    - main